#pragma once
#include "Window.h"
#include <luna/LinkedList.h>
#include <ui/Canvas.h>

struct Layer
{
    LinkedList<Window> windows;

    static Window* focused_window();
    static void draw_all_windows(ui::Canvas& canvas);
    static Window* propagate_mouse_event(ui::Point position, u8 buttons);
    static Window* propagate_drag_event(ui::Point position);
};

extern Layer l_background;
extern Layer l_global;
extern Layer l_global_top;
extern Layer l_system;
extern Layer l_lock;
